/**
 * @author Sergey Burkov, http://www.wp3dprinting.com
 * @copyright 2017
 */
jQuery(document).ready(function() {
	jQuery( ".woo3dv-color-picker" ).wpColorPicker({

		change : function(event, ui) {
			if (typeof(woo3dv)!='undefined') {
				woo3dvChangeModelColor(ui.color.toString());
			}
		},
		clear : function(event, ui) {
			if (typeof(woo3dv)!='undefined') {
				woo3dvChangeModelColor('#ffffff');
			}
		}

	});

jQuery(".woo3dv-noenter").on('keyup', function (e) {
    if (e.keyCode == 13) {
	e.preventDefault();
        return false;
    }
});

});


/**
 * Callback function for the 'click' event of the 'Set Footer Image'
 * anchor in its meta box.
 *
 * Displays the media uploader for selecting an image.
 *
 * @since 0.1.0
 */
function renderMediaUploader() {
    'use strict';
 
    var file_frame, image_data;
 
    /**
     * If an instance of file_frame already exists, then we can open it
     * rather than creating a new instance.
     */
    if ( undefined !== file_frame ) {
 
        file_frame.open();
        return;
 
    }
 
    /**
     * If we're this far, then an instance does not exist, so we need to
     * create our own.
     *
     * Here, use the wp.media library to define the settings of the Media
     * Uploader. We're opting to use the 'post' frame which is a template
     * defined in WordPress core and are initializing the file frame
     * with the 'insert' state.
     *
     * We're also not allowing the user to select more than one image.
     */
    file_frame = wp.media.frames.file_frame = wp.media({
        frame:    'post',
        state:    'insert',
        multiple: false
    });
 
    /**
     * Setup an event handler for what to do when an image has been
     * selected.
     *
     * Since we're using the 'view' state when initializing
     * the file_frame, we need to make sure that the handler is attached
     * to the insert event.
     */
    file_frame.on( 'insert', function() {

	var json = file_frame.state().get( 'selection' ).first().toJSON();

//	if( /[^a-zA-Z0-9\-]/.test( json.title ) ) {
//		alert('File name must not be  (a-z,0-9,-)');
//		return false;
//	}
	jQuery( '#product_model' ).val( json.url );
	jQuery( 'button.media-modal-close' ).click();
	jQuery( '#woo3dv_save_block' ).show();


/*
	$( '#footer-thumbnail-src' ).val( json.url );
	$( '#footer-thumbnail-title' ).val( json.title );
	$( '#footer-thumbnail-alt' ).val( json.title );
*/

    });
 
    // Now display the actual file_frame
    file_frame.open();
 
}
 
(function( $ ) {
    'use strict';
 
    $(function() {
        $( '#set-model' ).on( 'click', function( evt ) {
 
            // Stop the anchor's default behavior
            evt.preventDefault();
 
            // Display the media uploader
            renderMediaUploader();
 
        });
 
    });
 
})( jQuery );

function woo3dv_remove_model() {
	jQuery('#product_model').val('')
	jQuery('#product_model_name').html('')
	jQuery('#woo3dv-cv').hide()
}



function woo3dvChangeDisplayMode(mode) {
	if (mode!='png_image') {
		jQuery('#png_block').hide();
		jQuery('#product_image_data').val('');
	}
	else {
		jQuery('#png_block').show();
		jQuery('#woo3dv-canvas-instructions').show();
	}

	if (mode!='gif_image') {
		jQuery('#gif_block').hide();
		jQuery('#product_gif_data').val('');
	}
	else {
		jQuery('#woo3dv-canvas-instructions').show();
		jQuery('#gif_block').show();
	}

	if (mode!='webm_video') {
		jQuery('#webm_block').hide();
		jQuery('#product_webm_data').val('');
	}
	else {
		jQuery('#webm_block').show();
		jQuery('#woo3dv-canvas-instructions').show();
	}
	if (mode=='3d_model') {
		jQuery('#woo3dv-canvas-instructions').hide();
	}
}

function woo3dvCheckPostSize() {
	var post_max_size = parseInt(woo3dv.post_max_size) * 1048576; //bytes
	var post_size = jQuery('#product_image_data').val().length + jQuery('#product_gif_data').val().length + jQuery('#product_webm_data').val().length;
	if (post_size > post_max_size) {
		alert(woo3dv.text_post_max_size);
		return false;
	}
	return true;
}