<?php
/**
 *
 *
 * @author Sergey Burkov, http://www.wp3dprinting.com
 * @copyright 2017
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}



add_action( 'admin_menu', 'register_woo3dv_menu_page' );
function register_woo3dv_menu_page() {
	add_menu_page( 'Woo 3D Viewer', 'Woo 3D Viewer', 'manage_options', 'woo3dv', 'register_woo3dv_menu_page_callback' );
}

function register_woo3dv_menu_page_callback() {
	global $wpdb;
	if ( $_GET['page'] != 'woo3dv' ) return false;
	if ( !current_user_can('administrator') ) return false;

	$settings=woo3dv_get_option( 'woo3dv_settings' );

	if ( isset( $_POST['action'] ) && $_POST['action']=='save_login' ) {
		$settings['api_login']=sanitize_text_field($_POST['api_login']);
		update_option( 'woo3dv_settings', $settings );
	}



	if ( isset( $_POST['woo3dv_settings'] ) && !empty( $_POST['woo3dv_settings'] ) && check_admin_referer( 'woo3dv-save-settings_' )) {
	        $settings_update = array_map('sanitize_text_field', $_POST['woo3dv_settings']);

		if (isset($_FILES['woo3dv_settings']['tmp_name']['ajax_loader']) && strlen($_FILES['woo3dv_settings']['tmp_name']['ajax_loader'])>0) {
			$uploaded_file = woo3dv_upload_file('woo3dv_settings', 'ajax_loader');
			$settings_update['ajax_loader']=str_replace('http:','',$uploaded_file['url']);
		}
		else {
			$settings_update['ajax_loader']=$settings['ajax_loader'];
		}

		update_option( 'woo3dv_settings', $settings_update );
	}


	$settings=woo3dv_get_option( 'woo3dv_settings' );

	add_thickbox(); 
#	woo3dv_check_install();
?>

<script language="javascript">

jQuery(document).ready(function() {
	jQuery('.woo3dv-tooltip').tooltipster({ contentAsHTML: true, multiple: true });
});
</script>
<div class="wrap">
	<h2><?php _e( 'General settings', 'woo3dv' );?></h2>

	<div id="woo3dv_tabs">
		<div id="woo3dv_tabs-0">
			<form method="post" action="admin.php?page=woo3dv#woo3dv_tabs-0" enctype="multipart/form-data">
			<?php    wp_nonce_field( 'woo3dv-save-settings_' ); ?>
				<input type="hidden" value="stl,obj,zip" name="file_extensions">
				<hr>
				<p><b><?php _e( 'Product Viewer', 'woo3dv' );?></b></p>
				<table>
					<tr>
						<td><?php _e( 'Canvas Resolution', 'woo3dv' );?></td>
						<td><input size="3" type="text"  placeholder="<?php _e( 'Width', 'woo3dv' );?>" name="woo3dv_settings[canvas_width]" value="<?php echo $settings['canvas_width'];?>">px &times; <input size="3"  type="text" placeholder="<?php _e( 'Height', 'woo3dv' );?>" name="woo3dv_settings[canvas_height]" value="<?php echo $settings['canvas_height'];?>">px</td>
					</tr>
					<tr>
						<td><?php _e( 'Shading', 'woo3dv' );?></td>
						<td>
							<select name="woo3dv_settings[shading]">
								<option <?php if ( $settings['shading']=='flat' ) echo 'selected';?> value="flat"><?php _e( 'Flat', 'woo3dv' );?></option>
								<option <?php if ( $settings['shading']=='smooth' ) echo 'selected';?> value="smooth"><?php _e( 'Smooth', 'woo3dv' );?></option>
							</select> 
							<img class="woo3dv-tooltip" data-title="<img src='<?php echo plugins_url( 'woo-3d-viewer/images/shading.jpg' );?>'>" src="<?php echo plugins_url( 'woo-3d-viewer/images/question.png' ); ?>">
						</td>
					</tr>

					<tr>
						<td><?php _e( 'Background Color', 'woo3dv' );?></td>
						<td><input type="text" class="woo3dv-color-picker" name="woo3dv_settings[background1]" value="<?php echo $settings['background1'];?>"></td>
					</tr>
					<tr>
						<td><?php _e( 'Grid Color', 'woo3dv' );?></td>
						<td><input type="text" class="woo3dv-color-picker" name="woo3dv_settings[plane_color]" value="<?php echo $settings['plane_color'];?>"></td>
					</tr>
					<tr>
						<td><?php _e( 'Ground Color', 'woo3dv' );?></td>
						<td><input type="text" class="woo3dv-color-picker" name="woo3dv_settings[ground_color]" value="<?php echo $settings['ground_color'];?>"></td>
					</tr>
					<tr>
						<td><?php _e( 'Loading Image', 'woo3dv' );?></td>
						<td>
							<img class="woo3dv-preview" src="<?php echo esc_url($settings['ajax_loader']);?>">
							<input type="file" name="woo3dv_settings[ajax_loader]" accept="image/*">
						</td>
					</tr>

					<tr>
						<td><?php _e( 'Auto Rotation', 'woo3dv' );?></td>
						<td><input type="hidden" name="woo3dv_settings[auto_rotation]" value="0"><input type="checkbox" name="woo3dv_settings[auto_rotation]" <?php if ($settings['auto_rotation']=='on') echo 'checked';?>></td>
					</tr>

					<tr>
						<td><?php _e( 'Show Shadows', 'woo3dv' );?></td>
						<td><input type="hidden" name="woo3dv_settings[show_shadow]" value="0"><input type="checkbox" name="woo3dv_settings[show_shadow]" <?php if ($settings['show_shadow']=='on') echo 'checked';?>></td>
					</tr>
					<tr>
						<td><?php _e( 'Ground Mirror', 'woo3dv' );?></td>
						<td><input type="hidden" name="woo3dv_settings[ground_mirror]" value="0"><input type="checkbox" name="woo3dv_settings[ground_mirror]" <?php if ($settings['ground_mirror']=='on') echo 'checked';?>></td>
					</tr>

					<tr>
						<td><?php _e( 'Show Grid', 'woo3dv' );?></td>
						<td><input type="hidden" name="woo3dv_settings[show_grid]" value="0"><input type="checkbox" name="woo3dv_settings[show_grid]" <?php if ($settings['show_grid']=='on') echo 'checked';?>></td>
					</tr>
				</table>
				<hr>

				<p><b><?php _e( 'Other', 'woo3dv' );?></b></p>
				<table>

					<tr>
						<td><?php _e( 'Load Everywhere', 'woo3dv' );?></td>
						<td>
							<input type="hidden" name="woo3dv_settings[load_everywhere]" value="0">
							<input type="checkbox" name="woo3dv_settings[load_everywhere]" <?php if ($settings['load_everywhere']=='on') echo 'checked';?>>
							<img class="woo3dv-tooltip" data-title="<?php htmlentities(_e( 'Enable if you need to load Woo 3D viewer css and js files on all pages of the site.', 'woo3dv' ));?>" src="<?php echo plugins_url( 'woo-3d-viewer/images/question.png' ); ?>">
						</td>
					</tr>
					<tr>
						<td><?php _e( 'Skip animation on mobile devices', 'woo3dv' );?></td>
						<td>
							<input type="hidden" name="woo3dv_settings[mobile_no_animation]" value="0">
							<input type="checkbox" name="woo3dv_settings[mobile_no_animation]" <?php if ($settings['mobile_no_animation']=='on') echo 'checked';?>>
							<img class="woo3dv-tooltip" data-title="<?php htmlentities(_e( 'Disable rotation on mobile devices for better performance.', 'woo3dv' ));?>" src="<?php echo plugins_url( 'woo-3d-viewer/images/question.png' ); ?>">
						</td>
					</tr>




				</table>
				<p class="submit">
					<input type="submit" class="button-primary" value="<?php _e( 'Save Changes', 'woo3dv' ) ?>" />
				</p>
			</form>
		</div>  
	</div><!-- woo3dv_tabs -->
</div> <!-- wrap -->
<?php

}

add_action( 'add_meta_boxes', 'woo3dv_add_meta_boxes', 30 );
function woo3dv_add_meta_boxes() {
	add_meta_box( 'woo3dv-product-model', __( 'Product model', 'woo3dv' ), 'woo3dv_meta_box_output', 'product', 'side', 'low' );
}

function woo3dv_meta_box_output () {
	$product_model=$product_color='';
	$settings = get_option( 'woo3dv_settings' );
	$upload_dir = wp_upload_dir();
#print_r($upload_dir);
//var_dump(woo3dv_is_woo3dv((int)$_GET['post'] ));
	if ( isset($_GET['post']) && woo3dv_is_woo3dv((int)$_GET['post'] )) {
		$product_model = get_post_meta( (int)$_GET['post'], '_product_model', true );
		$display_mode = get_post_meta( (int)$_GET['post'], '_display_mode', true );
		$product_color = get_post_meta( (int)$_GET['post'], '_product_color', true );
		$product_shininess = get_post_meta( (int)$_GET['post'], '_product_shininess', true );
		$product_transparency = get_post_meta( (int)$_GET['post'], '_product_transparency', true );
		$product_mtl = get_post_meta( (int)$_GET['post'], '_product_mtl', true );
		$rotation_x = (int)get_post_meta( (int)$_GET['post'], '_rotation_x', true );
		$rotation_y = (int)get_post_meta( (int)$_GET['post'], '_rotation_y', true );
		$rotation_z = (int)get_post_meta( (int)$_GET['post'], '_rotation_z', true );
		$upload_url = dirname($product_model).'/';
	}

#print_r(get_post_meta( (int)$_GET['post']));
?>
	<div>
		<input type="hidden" id="product_model" name="product_model" value="<?php echo esc_attr( $product_model ); ?>" />


		<?php
		if ($product_model!='') {
		?>
		<div id="woo3dv_dialog" style="display:none;">
		<div id="woo3dv-viewer" style="<?php if ($product_model=='') echo 'display:none;';?>">
			<canvas id="woo3dv-cv" width="<?php echo esc_attr($settings['canvas_width']);?>" height="<?php echo esc_attr($settings['canvas_height']);?>" style="border: 1px solid;width:100%;"></canvas>
			<div id="woo3dv-file-loading">
				<img alt="Loading file" src="<?php echo esc_attr($settings['ajax_loader']); ?>">
			</div>
		</div>
		<p class="hide-if-no-js" id="woo3dv-canvas-instructions" style="<?php if ($display_mode=='3d_model') echo 'display:none;'?>">
			<?php #_e('Adjust angle with left mouse button. Zoom with scroll button. Adjust camera position with right mouse button.', 'woo3dv');; //todo remember camera position?>
		</p>
		<p class="hide-if-no-js" id="woo3dv-rotation-controls">
			<span class="woo3dv-x-axis"><?php _e('X','3dprint');?>:</span>
			<input type="number" autocomplete="off" class="woo3dv-dim-input" min="-360" max="360" step="90" value="<?php echo $rotation_x;?>" id="rotation_x" > <span class="woo3dv-separator">&deg; </span> 
			<span class="woo3dv-y-axis"><?php _e('Y','3dprint');?>:</span>
			<input type="number" autocomplete="off" class="woo3dv-dim-input" min="-360" max="360" step="90" value="<?php echo $rotation_y;?>" id="rotation_y" > <span class="woo3dv-separator">&deg; </span>
			<span class="woo3dv-z-axis"><?php _e('Z','3dprint');?>:</span>
			<input type="number" autocomplete="off" class="woo3dv-dim-input" min="-360" max="360" step="90" value="<?php echo $rotation_z;?>" id="rotation_z" > <span class="woo3dv-separator">&deg; </span>
		</p>
		<table>
		<tr>
			<td><?php _e('Color');?>:</td>
			<td><input type="text" class="woo3dv-color-picker" onchange="woo3dvChangeModelColor(this.value);" value="<?php echo $product_color;?>" /></td>
		</tr>
		<tr>
		<td><?php _e('Shininess', 'woo3dv');?>:</td>
		<td>
			<select onchange="woo3dvSetCurrentShininess(this.value);">
				<option <?php if ( $product_shininess=='plastic') echo "selected";?> value="plastic"><?php _e('Plastic', 'woo3dv');?></option>
				<option <?php if ( $product_shininess=='wood' ) echo "selected";?> value="wood"><?php _e('Wood', 'woo3dv');?></option>
				<option <?php if ( $product_shininess=='metal' ) echo "selected";?> value="metal"><?php _e('Metal', 'woo3dv');?></option>
			</select>
		</td>
		</tr>
		<tr>
		<td><?php _e('Transparency', 'woo3dv');?>:</td>
		<td>
			<select onchange="woo3dvSetCurrentTransparency(this.value);">
				<option <?php if ( $product_transparency=='opaque') echo "selected";?> value="opaque"><?php _e('Opaque', 'woo3dv');?></option>
				<option <?php if ( $product_transparency=='resin' ) echo "selected";?> value="resin"><?php _e('Resin', 'woo3dv');?></option>
				<option <?php if ( $product_transparency=='glass' ) echo "selected";?> value="glass"><?php _e('Glass', 'woo3dv');?></option>
			</select>
		</td>
		</tr>
		</table>
		</div>

		</p>

		<input type="hidden" id="woo3dv_model_url" value="<?php echo esc_attr($product_model);?>">
		<input type="hidden" id="woo3dv_model_mtl" value="<?php echo esc_attr(basename($product_mtl));?>">
		<input type="hidden" id="woo3dv_upload_url" value="<?php echo esc_attr( $upload_url ); ?>" />
		<input type="hidden" name="product_color" id="woo3dv_model_color" value="<?php echo esc_attr($product_color);?>">
		<input type="hidden" name="product_shininess" id="woo3dv_model_shininess" value="<?php echo esc_attr($product_shininess);?>">
		<input type="hidden" name="product_transparency" id="woo3dv_model_transparency" value="<?php echo esc_attr($product_transparency);?>">
		<input type="hidden" name="rotation_x" id="woo3dv_rotation_x" value="<?php echo esc_attr($rotation_x);?>">
		<input type="hidden" name="rotation_y" id="woo3dv_rotation_y" value="<?php echo esc_attr($rotation_y);?>">
		<input type="hidden" name="rotation_z" id="woo3dv_rotation_z" value="<?php echo esc_attr($rotation_z);?>">
		<input type="hidden" id="woo3dv_canvas_width" value="<?php echo esc_attr($settings['canvas_width']);?>">
		<input type="hidden" id="woo3dv_canvas_height" value="<?php echo esc_attr($settings['canvas_height']);?>">
		<input type="hidden" id="woo3dv_model_image_url" value="">

		<p class="hide-if-no-js">
			<button onclick="woo3dvPreview()" type="button"><?php _e('Preview','woo3dv');?></button>
		</p>
		<p class="hide-if-no-js">
		<div id="product_model_name" style="<?php if ($product_model=='') echo 'display:none;';?>">
		<?php
			echo '<a href="'.$product_model.'">'.basename($product_model).'</a>&nbsp;';
			echo '<a title="'.__('Remove', 'woo3dv').'" href="javascript:woo3dv_remove_model();">&#10006;</a>';

		?>
		</div>
			<br><br>
			<?php _e('Display mode', 'woo3dv');?>:<select onchange="woo3dvChangeDisplayMode(this.value)" name="display_mode">
				<option <?php if ( $display_mode=='3d_model') echo "selected";?> value="3d_model"><?php _e('3D model', 'woo3dv');?></option>
				<option <?php if ( $display_mode=='png_image') echo "selected";?> disabled value="png_image"><?php _e('PNG image', 'woo3dv');?></option>
				<option <?php if ( $display_mode=='gif_image') echo "selected";?> disabled value="gif_image"><?php _e('GIF image', 'woo3dv');?></option>
				<option <?php if ( $display_mode=='webm_video') echo "selected";?> disabled value="webm_video"><?php _e('WEBM video', 'woo3dv');?></option>
			</select> <br>Unlock in <a href="http://woo3dviewer.wp3dprinting.com/">PRO version</a><br><br>

		</p>
		<?php
		}
		?>

		<p id="woo3dv_save_block" class="hide-if-no-js" style="display:none;">
			<span style="color:green;"><?php _e('Uploaded! You can now save the product.', 'woo3dv'); ?></span>
		</p>


		<p class="hide-if-no-js">
			<a title="<?php _e( 'Set model', 'woo3dv' ); ?>" href="javascript:;" id="set-model"><?php _e( 'Set model', 'woo3dv' ); ?></a>
		</p>
	</div>
<?php
}
?>